using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace List_VCD_Properties
{
    public partial class Form1 : Form
    {
        private List<Control> _currentControls = new List<Control>();

        public Form1()
        {
            InitializeComponent();
        }

        

        private void Form1_Load(object sender, EventArgs e)
        {
            if( !icImagingControl1.LoadShowSaveDeviceState("lastSelectedDeviceState.xml") )
            {
                MessageBox.Show("No device was selected.");
                this.Close();
                return;
            }
            // J̐ݒ肵𑜓xɍ킹ĕ\ʂύX
            icImagingControl1.LiveDisplayDefault = false;
            icImagingControl1.LiveDisplaySize = icImagingControl1.Size;

            UpdateStateAfterDeviceSelect();
        }

        private void btnSelectDevice_Click(object sender, EventArgs e)
        {
            // CuXg[~O~
            if (icImagingControl1.LiveVideoRunning)
            {
                icImagingControl1.LiveStop();
            }

            //@foCXZbeBO_CAO\
            icImagingControl1.ShowDeviceSettingsDialog();

            // foCXȂꍇɂ͏I
            if (!icImagingControl1.DeviceValid)
            {
                MessageBox.Show("No device was selected.");
                this.Close();
                return;
            }

            UpdateStateAfterDeviceSelect();
        }

        private void UpdateStateAfterDeviceSelect()
        {

            //ׂẴvpeBvf(PropertyElement)AуC^[tFCX
            ListAllPropertyItems();

            //CuXg[~OJn
            icImagingControl1.LiveStart();

            // c[ r[
            BuildVCDPropertiesTree();
        }
        //>>

        //<<btnshowpage
        private void btnShowPage_Click(object sender, EventArgs e)
        {
            if (icImagingControl1.DeviceValid)
            {
                // gݍ݂̃vpeB _CAO\
                icImagingControl1.ShowPropertyDialog();
            }
        }

        
        private void BuildVCDPropertiesTreeItems(TreeNode pp, TIS.Imaging.VCDPropertyItems props)
        {
            // ׂĂ VCDPropertyItem 𔽕āAc[ɑ}܂
            foreach (TIS.Imaging.VCDPropertyItem item in props)
            {
                // ACe̐Vc[ m[h쐬܂
                TreeNode newNode = new TreeNode(item.Name, 0, 0);
                pp.Nodes.Add(newNode);
                //ݎgpĂ摜ƃJ̃vpeBc[ɕ\܂
                QueryVCDPropertyElements(newNode, item);
            }
        }


        //ݎgpĂ摜ƃJ̃vpeBc[ɕ\܂
        private void QueryVCDPropertyElements(TreeNode pp, TIS.Imaging.VCDPropertyItem item)
        {
            foreach (TIS.Imaging.VCDPropertyElement elem in item.Elements)
            {
                TreeNode newNode = null;

                if( elem.ElementGUID == TIS.Imaging.VCDGUIDs.VCDElement_Value )
                    newNode = new TreeNode("VCDElement_Value: '" + elem.Name + "'", 1, 1);
                else if ( elem.ElementGUID == TIS.Imaging.VCDGUIDs.VCDElement_Auto )
                    newNode = new TreeNode("VCDElement_Auto: '" + elem.Name + "'", 2, 2);       
                else if ( elem.ElementGUID == TIS.Imaging.VCDGUIDs.VCDElement_OnePush )
                    newNode = new TreeNode("VCDElement_OnePush: '" + elem.Name + "'", 3, 3);
                else if ( elem.ElementGUID == TIS.Imaging.VCDGUIDs.VCDElement_WhiteBalanceRed )
                    newNode = new TreeNode("VCDElement_WhiteBalanceRed: '" + elem.Name + "'", 4, 4);
                else if ( elem.ElementGUID == TIS.Imaging.VCDGUIDs.VCDElement_WhiteBalanceBlue )
                    newNode = new TreeNode("VCDElement_WhiteBalanceBlue: '" + elem.Name + "'", 4, 4);
                else
                    newNode = new TreeNode("Other Element ID: '" + elem.Name + "'", 4, 4);

                pp.Nodes.Add(newNode);

                // ׂẴC^[tF[X}
                QueryVCDPropertyInterface(newNode, elem);
            }
        }

        private void QueryVCDPropertyInterface(TreeNode pp, TIS.Imaging.VCDPropertyElement elem)
        {
            foreach (TIS.Imaging.VCDPropertyInterface itf in elem)
            {
                TreeNode newNode;
                if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_AbsoluteValue )
                    newNode = new TreeNode("AbsoluteValue", 4, 4);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_MapStrings )
                    newNode = new TreeNode("MapStrings", 6, 6);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Range )
                    newNode = new TreeNode("Range", 4, 4);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Switch )
                    newNode = new TreeNode("Switch", 5, 5);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Button )
                    newNode = new TreeNode("Button", 3, 3);
                else
                {
                    newNode = new TreeNode(itf.InterfaceGUID.ToString(), 4, 4);
                }

                // Tag vpeBm[hŃC^[tF[Xێ
                newNode.Tag = itf;
                pp.Nodes.Add(newNode);
            }
        }

        private void BuildVCDPropertiesTree()
        {
            // vpeB̃c[NAɂ
            Tree.Nodes.Clear();

            // vpeB̃c[\z
            TreeNode root = new TreeNode("VCDPropertyItems");
            Tree.Nodes.Add(root);

            BuildVCDPropertiesTreeItems(root, icImagingControl1.VCDPropertyItems);

            root.ExpandAll();
            Tree.SelectedNode = root;
        }

        private void treeView1_AfterSelect(object sender, TreeViewEventArgs e)
        {
            // TagvpeB̏ꍇAm[h͑IȂ
            if (Tree.SelectedNode.Tag == null)
            {
                return;
            }

            // ׂẴRg[B
            foreach( var ctrl in _currentControls )
            {
                ctrl.Dispose();
            }
            _currentControls.Clear();

            TIS.Imaging.VCDPropertyInterface itf = Tree.SelectedNode.Tag as TIS.Imaging.VCDPropertyInterface;
            if (itf != null)
            {
                itf.Update();
                // IC^[tF[X̃^CvɈvRg[O[v\A܂B
                if ( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_AbsoluteValue )
                     ShowAbsoluteValueControl(itf);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_MapStrings)
                    ShowComboBoxControl(itf);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Range)
                    ShowRangeControl(itf);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Switch)
                    ShowSwitchControl(itf);
                else if( itf.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Button)
                    ShowButtonControl(itf);
            }
        }




        //
        // ListAllPropertyItems
        // ̃TúAACe - vf - \z܂ 
        // -fobO EBhẼvpeBׂ̂Ă̖OƒlXg܂B 
        // ׂẴvpeBAvfAуC^[tFCX񋓂@Ă܂B 
        // ݂̃C^[tFCX̃vpeBɐANZXɂ́A
        // C^[tFCX͈́AΒlȂǂ̓K؂ȃC^[tFCX ^CvɁuLXgvKv܂B
        private void ListAllPropertyItems()
        {
            // ׂẴvpeB ACe擾
            foreach (TIS.Imaging.VCDPropertyItem PropertyItem in icImagingControl1.VCDPropertyItems)
            {
                System.Diagnostics.Debug.WriteLine(PropertyItem.Name);

                // ݂̃vpeB ACêׂẴvpeBvf擾
                foreach (TIS.Imaging.VCDPropertyElement PropertyElement in PropertyItem.Elements)
                {
                    System.Diagnostics.Debug.WriteLine("    Element : " + PropertyElement.Name);

                    // ݂̃vpeBvfׂ̂ẴC^[tFCX擾܂B
                    foreach (TIS.Imaging.VCDPropertyInterface PropertyInterFace in PropertyElement)
                    {
                        System.Diagnostics.Debug.Write("        Interface ");

                        try
                        {
                            // ݂̃C^[tFCXK؂Ȍ^ɃLXgāA
                            // ʂȃC^[tFCX vpeBɃANZX܂B


                            //AbsoluteValueFΒl^
                            if ( PropertyInterFace.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_AbsoluteValue )
                            {
                                var AbsoluteValue = (TIS.Imaging.VCDAbsoluteValueProperty)PropertyInterFace;
                                System.Diagnostics.Debug.Write("Absolute Value : ");
                                System.Diagnostics.Debug.WriteLine(AbsoluteValue.Value.ToString());
                            }
                            //MapStringsFXg^
                            else if ( PropertyInterFace.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_MapStrings )
                            {
                                var MapString = (TIS.Imaging.VCDMapStringsProperty)PropertyInterFace;
                                System.Diagnostics.Debug.Write("Mapstring : ");
                                System.Diagnostics.Debug.WriteLine(MapString.String);
                            }
                            //SwitchF؂ւ^
                            else if( PropertyInterFace.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Switch )
                            {
                                var Switch = (TIS.Imaging.VCDSwitchProperty)PropertyInterFace;
                                System.Diagnostics.Debug.Write("Switch : ");
                                System.Diagnostics.Debug.WriteLine(Switch.Switch.ToString());
                            }
                            //ButtonF{^^
                            else if( PropertyInterFace.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Button )
                            {
                                var Button = (TIS.Imaging.VCDButtonProperty)PropertyInterFace;
                                System.Diagnostics.Debug.WriteLine("Button");
                            }
                            //RangeF臒lí͈j^
                            else if( PropertyInterFace.InterfaceGUID == TIS.Imaging.VCDGUIDs.VCDInterface_Range )
                            {
                                var Range = (TIS.Imaging.VCDRangeProperty)PropertyInterFace;
                                System.Diagnostics.Debug.Write("Range : ");
                                System.Diagnostics.Debug.WriteLine(Range.Value.ToString());
                            }

                        }
                        catch( Exception ex )
                        {
                            System.Diagnostics.Debug.WriteLine("<error>:" + ex);
                        }
                    }
                }
            }
        }



        //AbsolutepXC_[Rg[pl
        private void ShowAbsoluteValueControl(TIS.Imaging.VCDPropertyInterface itf)
        {
            var newCtrl = new AbsValSlider((TIS.Imaging.VCDAbsoluteValueProperty)itf);
            CtrlFrame.Controls.Add(newCtrl);
            newCtrl.SetBounds(20, 20, 500, 27);
            CtrlFrame.Text = "Absolute Value";
            _currentControls.Add(newCtrl);
        }


        //MapStringspR{{bNXRg[pl
        private void ShowComboBoxControl(TIS.Imaging.VCDPropertyInterface itf)
        {
            var newCtrl = new StringCombo((TIS.Imaging.VCDMapStringsProperty)itf);
            CtrlFrame.Controls.Add(newCtrl);
            newCtrl.SetBounds(20, 20, 200, 27);
            CtrlFrame.Text = "MapStrings";
            _currentControls.Add(newCtrl);
        }

        //RangepXC_[Rg[pl
        private void ShowRangeControl(TIS.Imaging.VCDPropertyInterface itf)
        {
            var newCtrl = new RangeSlider((TIS.Imaging.VCDRangeProperty)itf);
            CtrlFrame.Controls.Add(newCtrl);
            newCtrl.SetBounds(20, 20, 200, 27);
            CtrlFrame.Text = "Range";
            _currentControls.Add(newCtrl);
        }

        //SwitchpRg[pl
        private void ShowSwitchControl(TIS.Imaging.VCDPropertyInterface itf)
        {
            var newCtrl = new Switch((TIS.Imaging.VCDSwitchProperty)itf);
            CtrlFrame.Controls.Add(newCtrl);
            newCtrl.SetBounds(20, 20, 200, 27);
            CtrlFrame.Text = "Switch";
            _currentControls.Add(newCtrl);
        }

        //ButtonpRg[pl
        private void ShowButtonControl(TIS.Imaging.VCDPropertyInterface itf)
        {
            var newCtrl = new PushButton((TIS.Imaging.VCDButtonProperty)itf);
            CtrlFrame.Controls.Add(newCtrl);
            newCtrl.SetBounds(20, 20, 100, 27);
            CtrlFrame.Text = "Button";
            _currentControls.Add(newCtrl);
        }


    }
}